"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var app = require("tns-core-modules/application");
var color_1 = require("tns-core-modules/color");
var ColorPicker = (function () {
    function ColorPicker() {
    }
    ColorPicker.prototype.show = function (initialColor, colorMode) {
        var _this = this;
        if (initialColor === void 0) { initialColor = '#FF4081'; }
        if (colorMode === void 0) { colorMode = 'RGB'; }
        return new Promise(function (resolve, reject) {
            try {
                var cMode = _this._getColorMode(colorMode);
                var activity = app.android.foregroundActivity || app.android.startActivity;
                new com.pavelsikun.vintagechroma.ChromaDialog.Builder()
                    .initialColor(new color_1.Color(initialColor).android)
                    .colorMode(cMode)
                    .indicatorMode(com.pavelsikun.vintagechroma.IndicatorMode.HEX)
                    .onColorSelected(new com.pavelsikun.vintagechroma.OnColorSelectedListener({
                    onColorSelected: function (colorInt) {
                        resolve(colorInt);
                    }
                }))
                    .create()
                    .show(activity.getSupportFragmentManager(), 'ChromaDialog');
            }
            catch (err) {
                reject(err);
            }
        });
    };
    ColorPicker.prototype._getColorMode = function (value) {
        switch (value) {
            case 'RGB':
                return com.pavelsikun.vintagechroma.colormode.ColorMode.RGB;
            case 'ARGB':
                return com.pavelsikun.vintagechroma.colormode.ColorMode.ARGB;
            case 'HSV':
                return com.pavelsikun.vintagechroma.colormode.ColorMode.HSV;
            default:
                return com.pavelsikun.vintagechroma.colormode.ColorMode.RGB;
        }
    };
    return ColorPicker;
}());
exports.ColorPicker = ColorPicker;
